<?php

class TimeTrackPlugin extends MantisPlugin {
 
	function register() {
		$this->name        = 'TimeTrack';
		$this->description = 'Allows for timetracking within an issue or outside an issue.';
		$this->version     = '0.97';
		$this->requires    = array('MantisCore'       => '1.2.0',);
		$this->author      = 'Cas Nuy';
		$this->contact     = 'Cas-at-nuy.info';
		$this->url         = 'http://www.nuy.info';
		$this->page			= 'config';
	}
 
 	/**
	 * Default plugin configuration.
	 */
	function config() {
		return array(
			'consultant_hourly_charge'		=> 10,
			'consultant_manday_definition'	=> 8,
			'timetrack_delete_threshold'	=> DEVELOPER,
			'timetrack_add_threshold '		=> DEVELOPER,
			'timetrack_admin_threshold'		=> ADMINISTRATOR,
			'timetrack_history'				=> OFF,
			'timetrack_maxrec'				=> 35,
			);
	}

	function init() { 
		plugin_event_hook( 'EVENT_MENU_MAIN', 'mainmenu1' );
		plugin_event_hook( 'EVENT_MENU_MANAGE', 'mainmenu2' );
		plugin_event_hook( 'EVENT_VIEW_BUG_EXTRA', 'timetrack_form1' );
	}

	
	function mainmenu1() {
		return array('<a href="'. plugin_page( 'print_mytime_tracking_page.php' ) . '">' . lang_get( 'mytimetrack' ) . '</a>' );
    }

	function mainmenu2() {
		return array('<a href="'. plugin_page( 'print_time_tracking_page.php' ) . '">' . lang_get( 'timetrack' ) . '</a>' );
    }
 
 	function timetrack_form1() {
		 include 'plugins/TimeTrack/ttform.php';
	}
	

/*CREATE TABLE `mantis_module_timetracking` (
  `id` int(11) NOT NULL auto_increment,
  `bugid` int(11) default NULL,
  `user` int(11) default NULL,
  `expenditure_date` date default NULL,
  `hours` double(15,3) default NULL,
  `costs` double(15,3) default NULL,
  `time_unit` enum('md','hr') default 'hr',
  `timestamp` bigint(20) unsigned zerofill NOT NULL default '00000000000000000000',
  `info` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
*/

/*	function schema() {
		return array(
			array( 'CreateTableSQL', array( plugin_table( 'timelog' ), "
				id					I				NOTNULL UNSIGNED ZEROFILL AUTOINCREMENT PRIMARY,
				bugid				I(11)			default NULL,
				user				I(11)			default NULL,
				expenditure_date	D				default NULL,
				hours 				Double(15.3)	default NULL,
				costs 				Double(15,3)	default NULL,
				time_unit 			enum('md','hr')	default 'hr',
				timestamp 			I				unsigned zerofill NOT NULL ,
				info 				C(255)			default NULL,
				" ) ),
		);
	}
*/
}