<?php
########################################################
# Mantis Bugtracker plugin Time Track
#
# Based upon Time Tracker by Elmar Schumacher (elmar.schumacher@web.de)  GAMBIT Consulting GmbH
#
# converted to plugin for version 1.2 and above by
# Cas Nuy www.NUy.info 2010
#
########################################################
require_once( 'core.php' );
$t_core_path = config_get( 'core_path' );
require_once( $t_core_path.'current_user_api.php' );
require_once( $t_core_path.'bug_api.php' );
require_once( $t_core_path.'date_api.php' );
require_once( $t_core_path.'icon_api.php' );
require_once( $t_core_path.'string_api.php' );
require_once( $t_core_path.'columns_api.php' ); 

$t_plugin_path = config_get( 'plugin_path' ); 
require_once( $t_plugin_path . 'TimeTrack/TimeTrack_api.php' );


auth_ensure_user_authenticated();
$t_cookie_value_id = gpc_get_cookie( config_get( 'view_all_cookie' ), '' );
$t_cookie_value = filter_db_get_filter( $t_cookie_value_id );
html_page_top1( lang_get( 'summary_link' ) );
html_page_top2() ;
?>
<br />
<?php
$t_project_id = 0;
$informer     = auth_get_current_user_id();
$day_from     = $_REQUEST['day_from'];
$month_from   = $_REQUEST['month_from'];
$year_from    = $_REQUEST['year_from'];
$day_to       = $_REQUEST['day_to'];
$month_to     = $_REQUEST['month_to'];
$year_to      = $_REQUEST['year_to'];

if(empty($day_from)){
	$day_from   = 1;
	$month_from = date('m');
	$year_from  = date('Y');
	$day_to     = date('d');
	$month_to   = $month_from;
	$year_to    = $year_from;
}
if ( ! is_blank( $t_cookie_value ) ) {
    # check to see if new cookie is needed
    if ( ! filter_is_cookie_valid() ) {
      print_header_redirect( 'view_all_set.php?type=0&amp;print=1' );
    }
    $t_setting_arr = explode( '#', $t_cookie_value, 2 );
    $t_filter_cookie_arr = unserialize( $t_setting_arr[1] );
    $f_highlight_changed  = $t_filter_cookie_arr['highlight_changed'];
    $f_sort         = $t_filter_cookie_arr['sort'];
    $f_dir          = $t_filter_cookie_arr['dir'];
    $t_project_id       = helper_get_current_project( );
  }
?>
<form method="post" action="<?php echo plugin_page( 'print_mytime_tracking_page.php' ); ?>">
<table class="width100" cellpadding="2px">
<?php 
$t_icon_path = config_get( 'icon_path' );
?>
<tr>
<td>
<?php
if ( 'DESC' == $f_dir ) {
	$t_new_dir = 'ASC';
} else {
    $t_new_dir = 'DESC';
}
$t_search = urlencode( $f_search );
$xls_page=plugin_page( 'print_time_tracking_page_excel');
$t_icons = array(
      array( $xls_page, 'excel', '', 'excelicon.gif', 'Excel' ) );
foreach ( $t_icons as $t_icon ) {
      echo '<a href="' . $t_icon[0] . '.php' .
        "&amp;informer=$informer" .
        "&amp;day_from=$day_from" .
        "&amp;month_from=$month_from" .
        "&amp;year_from=$year_from" .
        "&amp;day_to=$day_to" .
        "&amp;month_to=$month_to" .
        "&amp;year_to=$year_to" .
        '" ' . $t_icon[2] . '>' .
        '<img src="' . $t_icon_path . $t_icon[3] . '" border="0" align="absmiddle" alt="' . $t_icon[4] . '"></a> ';
}
?>
</td>
<td>&nbsp;&nbsp;&nbsp;&nbsp;
<?php 
echo lang_get( 'print_time_tracking_from' ) ;
$current_date = explode ("-", date("Y-m-d"));
?>
<!-- values for restoring old situation
<select tabindex="1" name="day_from"><option value="0">-</option>
<?php print_day_option_list( $current_date[2] ) ?>
</select>
<select tabindex="2" name="month_from"><option value="0">-</option>
<?php print_month_option_list( $current_date[1] ) ?>
</select>
<select tabindex="3" name="year_from"><option value="0">-</option>
<?php print_year_option_list( $current_date[0] ) ?>
</select>
-->
<select tabindex="1" name="day_from"><option value="0">-</option>
<?php print_day_option_list( $day_from ) ?>
 </select>
<select tabindex="2" name="month_from"><option value="0">-</option>
<?php print_month_option_list( $month_from ) ?>
</select>
<select tabindex="3" name="year_from"><option value="0">-</option>
<?php print_year_option_list( $year_from ) ?>
</select>
&nbsp;&nbsp;
<?php echo lang_get( 'print_time_tracking_to' ) ?>
<select tabindex="4" name="day_to"><option value="0">-</option>
<?php print_day_option_list( $day_to ) ?>
</select>
<select tabindex="5" name="month_to"><option value="0">-</option>
<?php print_month_option_list( $month_to ) ?>
</select>
<select tabindex="6" name="year_to"><option value="0">-</option>
<?php print_year_option_list( $year_to ) ?>
</select>
<input tabindex="7" type="submit" name="Send" value="<?php echo lang_get( 'print_time_tracking_update' ) ?>" />
</td>
</tr>
</table>
</form>
<br />
<form method="post" action="<?php echo plugin_page( 'print_mytime_tracking_page.php' ); ?>">
<table class="width100" cellspacing="1" cellpadding="2px">
<tr>
<td class="form-title" colspan="7">
<?php echo lang_get( 'viewing_bugs_title' ) ?>    
</td>  
</tr>
<tr class="row-category">
<td><?php echo lang_get( 'priority' ) ?></td>
<td><?php echo lang_get( 'id' ) ?></td>
<td><?php echo lang_get( 'category' ) ?></td>
<td><?php echo lang_get( 'severity' ) ?></td>
<td><?php echo lang_get( 'status' ) ?></td>
<td><?php echo lang_get( 'recorded' ) ?></td>
<td><?php echo lang_get( 'summary' ) ?></td>
<td><?php echo lang_get( 'time_user' ); ?></td>
<td><?php echo lang_get( 'time_information' ); ?></td>
<td><?php echo lang_get( 'time_expenditure_date' ); ?></td>
<td><?php echo lang_get( 'time_hours' ); ?></td>
</tr>
<tr>
<td class="spacer" colspan="9">&nbsp;</td>
</tr>
<?php
// Get results
$all_reported_bugs_query="select t.id,b.priority,b.id,b.category_id,c.name,b.severity,b.status,t.timestamp,b.summary,t.user,t.info,t.hours,t.expenditure_date from $time_table t, $bug_table b,$category_table c where t.bugid=b.id and b.category_id=c.id ";
if (empty($informer) ) {
	$informer =0 ;
	$all_reported_bugs_query=$all_reported_bugs_query." and t.user=" . $informer;
} else {
	$all_reported_bugs_query=$all_reported_bugs_query." and t.user=" . $informer;
}
if (!empty($day_from) && !empty($day_to) && !empty($month_from) && !empty($month_to) && !empty($year_from) && !empty($year_to)) {
  $all_reported_bugs_query=$all_reported_bugs_query." and t.expenditure_date between '" . $year_from . "-" . $month_from . "-" . $day_from . "' and '" . $year_to . "-" . $month_to . "-" . $day_to . "'"; 
}
if ($t_project_id!=0) {
  $all_reported_bugs_query=$all_reported_bugs_query . " and b.project_id=".$t_project_id;
} 
$all_reported_bugs_query=$all_reported_bugs_query . " order by t.expenditure_date ";
$result_timerecords = db_query_bound($all_reported_bugs_query);
$num_timerecords = db_num_rows( $result_timerecords );

$total_hours=0;
for( $i=0; $i < $num_timerecords; $i++ ) {
    $t_row = db_fetch_array( $result_timerecords );
    # alternate row colors
    $status_color = helper_alternate_colors( $i, '#ffffff', '#dddddd' );
    $total_hours+=$t_row['hours'];    
?>
	<tr bgcolor="<?php echo $status_color ?>" border="1">  
	<td><?php echo get_enum_element( 'priority', $t_row["priority"]) ?></td>
	<td><a href="view.php?id=<?php echo $t_row["id"] ?>"><?php echo bug_format_id( $t_row["id"]) ?></a></td>
	<td><?php echo $t_row["category"] ?></td>
	<td><?php echo get_enum_element( 'severity', $t_row["severity"]) ?></td>
	<td><?php echo get_enum_element( 'status', $t_row["status"]) ?></td>
	<td><?php echo substr($t_row["timestamp"],0,10) ?></td>
	<td><?php echo $t_row["summary"] ?></td>
	<td><?php echo user_get_name($t_row["user"]) ?></td>
	<td><?php echo $t_row["info"] ?></td>
	<td><?php echo substr($t_row["expenditure_date"],0,10) ?></td>
	<td align="right"><?php echo number_format($t_row["hours"], 2, ',', '.') ?></td>
	</tr>
<?php
} # for_loop */
$status_color = helper_alternate_colors( $i, '#ffffff', '#dddddd' );
?>
<tr class="row-category"><td colspan="10" align="right"><b>Total</b></td><td align="right"><?php echo number_format($total_hours,2,',','.') ?></td></tr>
<input type="hidden" name="show_flag" value="1" />
</table>
<br />
</form>
<?php
html_page_bottom1( __FILE__ );